/**
 * otplib
 *
 * @author Gerald Yeo <contact@fusedthought.com>
 * @version: 10.1.0-0
 * @license: MIT
 **/
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault(ex) {
  return ex && typeof ex === 'object' && 'default' in ex ? ex['default'] : ex;
}

var hotp = _interopDefault(require('./hotp'));
var totp = _interopDefault(require('./totp'));
var authenticator = _interopDefault(require('./authenticator'));
var crypto = _interopDefault(require('crypto'));

authenticator.options = { crypto };
hotp.options = { crypto };
totp.options = { crypto };

exports.hotp = hotp;
exports.totp = totp;
exports.authenticator = authenticator;